/* gm3d_polygon_box.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>



int main (int argc, char *argv[])
{
  double originX, originY, originZ;
  double cornerX, cornerY, cornerZ;
  FILE *fp;

  if (argc != 8) {
    fprintf 
      (stderr, 
       " Usage : \n"
       " gm3d_polygon_box  "
       "     originX originY originZ \n"
       "     cornerX cornerY cornerZ \n"
       "     polygon_file_OUT \n");
    exit (1);
  }

  originX = atof (argv[1]);
  originY = atof (argv[2]);
  originZ = atof (argv[3]);
  cornerX = atof (argv[4]);
  cornerY = atof (argv[5]);
  cornerZ = atof (argv[6]);

  fp = fopen (argv[7], "w");
  assert(fp != NULL);

  fprintf (fp, "6\n");

  fprintf (fp, "0   1\n");
  fprintf (fp, "  4\n");
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   originX, originY, originZ);
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   originX, cornerY, originZ);
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   cornerX, cornerY, originZ);
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   cornerX, originY, originZ);

  fprintf (fp, "1   1\n");
  fprintf (fp, "  4\n");
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   originX, originY, cornerZ);
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   cornerX, originY, cornerZ);
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   cornerX, cornerY, cornerZ);
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   originX, cornerY, cornerZ);

  fprintf (fp, "2   1\n");
  fprintf (fp, "  4\n");
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   originX, cornerY, originZ);
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   originX, originY, originZ);
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   originX, originY, cornerZ);
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   originX, cornerY, cornerZ);

  fprintf (fp, "3   1\n");
  fprintf (fp, "  4\n");
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   cornerX, originY, originZ);
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   cornerX, cornerY, originZ);
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   cornerX, cornerY, cornerZ);
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   cornerX, originY, cornerZ);

  fprintf (fp, "4   1\n");
  fprintf (fp, "  4\n");
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   originX, originY, originZ);
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   cornerX, originY, originZ);
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   cornerX, originY, cornerZ);
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   originX, originY, cornerZ);

  fprintf (fp, "5   1\n");
  fprintf (fp, "  4\n");
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   cornerX, cornerY, originZ);
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   originX, cornerY, originZ);
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   originX, cornerY, cornerZ);
  fprintf (fp, "  %22.15e %22.15e %22.15e\n",
	   cornerX, cornerY, cornerZ);

  fclose (fp);

  return 0;
}
