/* header file for autoage_scalar.c */

#ifndef __AUTOAGE_SCALAR__
#define __AUTOAGE_SCALAR__



/* Scalar */

void AutoAGE_Scalar_SortPair 
(double *value0_IO, double *value1_IO); 

int /* boolean */ 
AutoAGE_Scalar_MinMaxPairsOverlap 
(double min0, double max0, 
 double min1, double max1);

int /* boolean */ 
AutoAGE_Scalar_ValuesOverlap 
(double value0_0, double value0_1, 
 double value1_0, double value1_1);

typedef enum {
  AUTOAGE_SCALAR_OVERLAP_HAS_NO_OVERLAP_MIN0_MAX0_MIN1_MAX1, 
  AUTOAGE_SCALAR_OVERLAP_TOUCHES_MIN0_MAX0_AS_MIN1_MAX1, 
  AUTOAGE_SCALAR_OVERLAP_INTERSECTS_MIN0_MIN1_MAX0_MAX1, 
  AUTOAGE_SCALAR_OVERLAP_CONTAINS_MIN0_MIN1_MAX1_MAX0, 
  AUTOAGE_SCALAR_OVERLAP_CONTAINS_MIN0_AS_MIN1_MAX1_MAX0, 
  AUTOAGE_SCALAR_OVERLAP_CONTAINS_MIN0_MIN1_MAX1_AS_MAX0, 
  AUTOAGE_SCALAR_OVERLAP_MATCHES_MIN0_AS_MIN1_MAX0_AS_MAX1, 
  AUTOAGE_SCALAR_OVERLAP_IS_CONTAINED_MIN1_MIN0_MAX0_MAX1, 
  AUTOAGE_SCALAR_OVERLAP_IS_CONTAINED_MIN1_AS_MIN0_MAX0_MAX1, 
  AUTOAGE_SCALAR_OVERLAP_IS_CONTAINED_MIN1_MIN0_MAX0_AS_MAX1, 
  AUTOAGE_SCALAR_OVERLAP_INTERSECTS_MIN1_MIN0_MAX1_MAX0, 
  AUTOAGE_SCALAR_OVERLAP_TOUCHES_MIN1_MAX1_AS_MIN0_MAX0, 
  AUTOAGE_SCALAR_OVERLAP_HAS_NO_OVERLAP_MIN1_MAX1_MIN0_MAX0
} AutoAGE_Scalar_OverlapType;

AutoAGE_Scalar_OverlapType 
AutoAGE_Scalar_CheckOverlapOfMinMaxPairs 
(double min0, double max0, 
 double min1, double max1);

double AutoAGE_Scalar_SolutionOfFirstOrderEquation 
(double a, double b);

typedef enum {
  AUTOAGE_SCALAR_SOES_REAL, 
  AUTOAGE_SCALAR_SOES_DUPLICATED_REAL, 
  AUTOAGE_SCALAR_SOES_IMAGINARY
} AutoAGE_Scalar_SecondOrderEquationSolutionType;

AutoAGE_Scalar_SecondOrderEquationSolutionType 
AutoAGE_Scalar_SolveSecondOrderEquation 
(double a, double b, double c,
 double *x0_OUT, double *x1_OUT);

double AutoAGE_Scalar_Determinant2D 
(double a00, double a01,
 double a10, double a11);

int /* boolean */ 
AutoAGE_Scalar_SolveLinearEquation2D 
(double a00, double a01,
 double a10, double a11, 
 double b0, double b1,
 double *x_OUT, double *y_OUT);

double AutoAGE_Scalar_Determinant3D 
(double a00, double a01, double a02,
 double a10, double a11, double a12,
 double a20, double a21, double a22);

int /* boolean */ 
AutoAGE_Scalar_SolveLinearEquation3D 
(double a00, double a01, double a02,
 double a10, double a11, double a12,
 double a20, double a21, double a22, 
 double b0, double b1, double b2,
 double *x_OUT, double *y_OUT, double *z_OUT);



#endif  /* __AUTOAGE_SCALAR__ */
