/* test_base.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>

#include <autores.h>

#include "autoage_base.h"



static void Test0 (void)
{



  printf (" Test0 \n"); 



  assert(AutoAGE_eq (0.0, 0.0));
  assert(!AutoAGE_eq (0.0, 1.0));
  assert(AutoAGE_eq (0.0, AutoAGE_eps / 10));
  assert(AutoAGE_eq (0.0, -AutoAGE_eps / 10));
  assert(!AutoAGE_eq (0.0, AutoAGE_eps * 10));
  assert(!AutoAGE_eq (0.0, -AutoAGE_eps * 10));

  assert(AutoAGE_ne (0.0, 1.0));
  assert(!AutoAGE_ne (0.0, 0.0));
  assert(!AutoAGE_ne (0.0, AutoAGE_eps / 10));
  assert(!AutoAGE_ne (0.0, -AutoAGE_eps / 10));
  assert(AutoAGE_ne (0.0, AutoAGE_eps * 10));
  assert(AutoAGE_ne (0.0, -AutoAGE_eps * 10));

  assert(AutoAGE_ge (1.0, 0.0));
  assert(!AutoAGE_ge (0.0, 1.0));
  assert(AutoAGE_ge (0.0, 0.0));
  assert(AutoAGE_ge (0.0, AutoAGE_eps / 10));
  assert(!AutoAGE_ge (0.0, AutoAGE_eps * 10));

  assert(AutoAGE_le (0.0, 1.0));
  assert(!AutoAGE_le (1.0, 0.0));
  assert(AutoAGE_le (0.0, 0.0));
  assert(AutoAGE_le (0.0, -AutoAGE_eps / 10));
  assert(!AutoAGE_le (0.0, -AutoAGE_eps * 10));

  assert(AutoAGE_gt (1.0, 0.0));
  assert(!AutoAGE_gt (0.0, 1.0));
  assert(!AutoAGE_gt (0.0, 0.0));
  assert(!AutoAGE_gt (0.0, -AutoAGE_eps / 10));
  assert(AutoAGE_gt (0.0, -AutoAGE_eps * 10));

  assert(AutoAGE_lt (0.0, 1.0));
  assert(!AutoAGE_lt (1.0, 0.0));
  assert(!AutoAGE_lt (0.0, 0.0));
  assert(!AutoAGE_lt (0.0, AutoAGE_eps / 10));
  assert(AutoAGE_lt (0.0, AutoAGE_eps * 10));

  assert(AutoAGE_between (0.5, 0.0, 1.0));
  assert(!AutoAGE_between (1.5, 0.0, 1.0));
  assert(AutoAGE_between (0.0, 0.0, 1.0));
  assert(AutoAGE_between (1.0, 0.0, 1.0));
  assert(AutoAGE_between (0.5, 1.0, 0.0));
  assert(!AutoAGE_between (1.5, 1.0, 0.0));
  assert(AutoAGE_between (0.0, 1.0, 0.0));
  assert(AutoAGE_between (1.0, 1.0, 0.0));

  assert(AutoAGE_justBetween (0.5, 0.0, 1.0));
  assert(!AutoAGE_justBetween (1.5, 0.0, 1.0));
  assert(!AutoAGE_justBetween (0.0, 0.0, 1.0));
  assert(!AutoAGE_justBetween (1.0, 0.0, 1.0));
  assert(AutoAGE_justBetween (0.5, 1.0, 0.0));
  assert(!AutoAGE_justBetween (1.5, 1.0, 0.0));
  assert(!AutoAGE_justBetween (0.0, 1.0, 0.0));
  assert(!AutoAGE_justBetween (1.0, 1.0, 0.0));

  assert(AutoAGE_eq (AutoAGE_min (0.0, 1.0), 0.0));

  assert(AutoAGE_eq (AutoAGE_max (0.0, 1.0), 1.0));

  assert(AutoAGE_eq (AutoAGE_interpolate (1.0, 3.0, 0.3), 1.6));
  assert(AutoAGE_eq (AutoAGE_interpolate (1.0, 3.0, 1.7), 4.4));
  assert(AutoAGE_eq (AutoAGE_interpolate (1.0, 3.0, -0.7), -0.4));

  assert(AutoAGE_eq (AutoAGE_rangedValue (1.0, 0.0, 2.0), 1.0));
  assert(AutoAGE_eq (AutoAGE_rangedValue (3.0, 0.0, 2.0), 2.0));
  assert(AutoAGE_eq (AutoAGE_rangedValue (-1.0, 0.0, 2.0), 0.0));
  assert(AutoAGE_eq (AutoAGE_rangedValue (1.0, 2.0, 0.0), 1.0));
  assert(AutoAGE_eq (AutoAGE_rangedValue (3.0, 2.0, 0.0), 2.0));
  assert(AutoAGE_eq (AutoAGE_rangedValue (-1.0, 2.0, 0.0), 0.0));
}

int main (int argc, char *argv[])
{
  AutoRes_Initialize (0);

  Test0 ();

  return 0;
}



